(function ($, Drupal, drupalSettings) {

  Drupal.views_svg_animation = Drupal.views_svg_animation || {};
  drupalSettings.svg_animation = drupalSettings.svg_animation || {};

  Drupal.behaviors.views_svg_animation = {
    attach: function () {
      $('.views-svg-animation').once('views-svg-animation-process').each(function (index, element) {
        let w = $(element).width();
        if (w > drupalSettings.svg_animation.breakpoint) {
          drupalSettings.svg_animation.files.forEach(function (item) {
            if (drupalSettings.svg_animation.first_id === undefined) {
              drupalSettings.svg_animation.first_id = item['id'];
            }
            let el = document.createElement('div');
            $(el)
              .hide()
              .addClass('svg-image')
              .attr('svg-animation-object-id', item['id'])
              .load(item['path']);

            $('.svg-wrapper', element).append(el);
          });
        }
        $('tbody tr', element).hover(function () {
          let object = $(this).attr('svg-animation-object-id');
          let item = $(this).attr('svg-animation-item-id');
          Drupal.views_svg_animation.showSvgFile(element, object);
          $('.svg-animation-show', element).removeClass('svg-animation-show');
          $('.svg-wrapper .svg-image', element).addClass('svg-animation-show');
          $('tr[svg-animation-item-id='+item+']', element).addClass('svg-animation-show');
          $('.svg-wrapper .svg-image[svg-animation-object-id='+object+'] #'+item, element).addClass('svg-animation-show');
        });
        $('tbody', element).hover(function () {
          // Intentionally empty.
        }, function () {
          $('.svg-animation-show', element).removeClass('views-svg-animation-show-svg');
          Drupal.views_svg_animation.showSvgFile(element, drupalSettings.svg_animation.first_id);
        });
        $('.svg-wrapper', element).show();
        Drupal.views_svg_animation.showSvgFile(element, drupalSettings.svg_animation.first_id);
      });
    }
  };

  Drupal.views_svg_animation.showSvgFile = function (element, object) {
    $('.svg-wrapper .svg-image', element).hide();
    $('.svg-wrapper .svg-image[svg-animation-object-id='+object+']', element).show();
  };

})(jQuery, Drupal, drupalSettings);
